# ---------------------------------------------------------------------------
# The contents of this file are subject to the JOnAS Public License Version 
# 1.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License on the JOnAS web site.
#
# Software distributed under the License is distributed on an "AS IS" basis,
# WITHOUT WARRANTY OF ANY KIND, either express or implied.
# See the License for the specific terms governing rights and limitations
# under the License.
#
# The Original Code is JOnAS application server code released July 1999.
#
# The Initial Developer of the Original Code is Bull S.A.
# The Original Code and portions created by Bull S.A. are
#    Copyright (C) 1999 Bull S.A. All Rights Reserved.
#
# Contributor(s): ______________________________________.
#
# ---------------------------------------------------------------------------
# $Id$
# ---------------------------------------------------------------------------

# common Makefile

empty :=
space := $(empty) $(empty)

.SUFFIXES: .java .class _Skel.class .jj .sh .txt .ser .jpp

ifeq ($(JDKVERSION), 1.1)
ifeq ($(OSTYPE), cygwin32)
JDKDIR = /jdk1.1.7B
else
JDKDIR = /usr/java1.1
endif
OBJECTWEB_JDK = JAVA1
else
ifeq ($(OSTYPE), cygwin32)
JDKDIR = /jdk1.2.2
else
JDKDIR = /usr/java1.2
endif
OBJECTWEB_JDK = JAVA2
endif

ifeq ($(JDKBIN),)
JDKBIN = $(JDKDIR)/bin
endif

ifeq ($(JAR),)
JAR = $(JDKBIN)/jar
endif
ifeq ($(RMIC),)
RMIC = $(JDKBIN)/rmic
endif
ifeq ($(JAVA),)
JAVA = $(JDKBIN)/java
endif
ifeq ($(JAVAC),)
JAVAC = $(JDKBIN)/javac
endif
ifeq ($(JAVADOC),)
JAVADOC = $(JDKBIN)/javadoc
endif
ifeq ($(JAVACC),)
JAVACC = javacc
endif

CHECKEJB = $(JONAS_ROOT)/bin/CheckEJB
GENIC = $(JONAS_ROOT)/bin/GenIC
GENDD = $(JONAS_ROOT)/bin/GenDD

JPP = $(JAVA) org.objectweb.build.JPP


ifndef OUTPUT_DIR
OUTPUT_DIR = $(ROOT)/output
endif
ifndef CLASS_DIR
CLASS_DIR = $(ROOT)/classes
endif
ifndef SRCTMP_DIR
SRCTMP_DIR = $(ROOT)/tmp
endif
ifndef JAVADOC_DIR
JAVADOC_DIR = $(OUTPUT_DIR)/jdoc
endif
ifndef LIB_DIR
LIB_DIR = $(OUTPUT_DIR)/lib
endif
ifndef BIN_DIR
BIN_DIR = $(OUTPUT_DIR)/bin
endif


PACKDIR = $(subst .,/,$(JAVAPACKAGE))
CLASSPACKDIR = $(CLASS_DIR)/$(PACKDIR)
COPYSRCDIR = $(SRCTMP_DIR)/$(PACKDIR)
PWDSRC = $(ROOT)/src/$(PACKDIR)

ifndef SERDIR
SERDIR = $(CLASSPACKDIR)
endif

ifeq ($(JONAS_CLASSES),)
JONAS_CLASSES = $(JONAS_ROOT)/lib/jonas.jar
endif

ifeq ($(JPP_CLASSES),)
JPP_CLASSES = $(JONAS_ROOT)/lib/jpp.jar
endif

ifeq ($(JDBCEXT_CLASSES),)
JDBCEXT_CLASSES = /usr/local/lib/jdbc2_0-stdext.jar
endif

ifeq ($(JTA_CLASSES),)
	JTA_CLASSES = /usr/local/lib/jta-spec1_0_1.jar
endif

ifeq ($(JDKVERSION), 1.2)
	ifeq ($(EJB11_CLASSES),)
		EJB11_CLASSES = /usr/local/lib/ejb.jar
	endif
endif

ifeq ($(JNDI_CLASSES),)
	JNDI_HOME = /usr/local/lib2
	JNDI_CLASSES = $(JNDI_HOME)/jndi.jar$(PS)$(JNDI_HOME)/providerutil.jar$(PS)$(JNDI_HOME)/rmiregistry.jar
endif

ifeq ($(IDB_CLASSES),)
	IDB_CLASSES = /usr/local/lib/idb.jar$(PS)/usr/local/lib/idbexmpl.jar
endif
ifeq ($(ORACLE_CLASSES),)
	ORACLE_CLASSES = /usr/local/lib/classes111.zip
endif
ifeq ($(JDBC_CLASSES),)
	JDBC_CLASSES = $(IDB_CLASSES)$(PS)$(ORACLE_CLASSES)
endif

CLASSPATH := $(JDBC_CLASSES)$(PS)$(JNDI_CLASSES)$(PS)$(EJB11_CLASSES)$(PS)$(JTA_CLASSES)$(PS)$(JDBCEXT_CLASSES)$(PS)$(JPP_CLASSES)$(PS)$(JONAS_CLASSES)$(PS)$(CLASSPATH)

JPPFLAGS += -D $(OBJECTWEB_JDK) -D $(OBJECTWEB_ORB) -I $(ROOT)/src/include

ifneq ($(JCFLAGS),)
GENICFLAGS += -javacopts "$(JCFLAGS)"
endif
ifneq ($(RMICFLAGS),)
GENICFLAGS += -rmicopts "$(RMICFLAGS)"
endif

ifeq ($(EXPLICIT_PROP),true)
GENICFLAGS += -noimplpropag
endif

RMICFLAGS = -keepgenerated
ifeq ($(JDKVERSION), 1.2)
RMICFLAGS += -v1.1 
endif

FILE_EJBJAR = $(CLASS_DIR)/$(JAVAPACKAGE).jar
FILE_MANIFEST = $(CLASSPACKDIR)/manifest.mf

FILES_STUB = $(RMI_CLASSES:%=$(CLASSPACKDIR)/%_Stub.java)
FILES_SKEL = $(RMI_CLASSES:%=$(CLASSPACKDIR)/%_Skel.java)
FILES_RMI = $(RMI_CLASSES:%=$(CLASSPACKDIR)/%_Skel.class)
FILES_CLASS = $(CLASSES:%=$(CLASSPACKDIR)/%.class) $(RMI_CLASSES:%=$(CLASSPACKDIR)/%.class)
FILES_SRC = $(CLASSES:%=$(COPYSRCDIR)/%.java) $(RMI_CLASSES:%=$(COPYSRCDIR)/%.java)
FILES_SCRIPTS = $(SCRIPTS:%=$(SERDIR)/%)
FILES_COMMAND = $(COMMANDS:%=$(BIN_DIR)/%)
FILES_PARSER = $(JAVACCFILES:%=./.javacc_output/%.output)
FILES_SER = $(BEANDD:%=$(SERDIR)/%.ser)
FILES_SER_MF = $(BEANDD:%=$(PACKDIR)/%.ser)
FILES_GENIC = $(BEANDD:%=$(CLASSPACKDIR)/%.genic_output)


$(CLASSPACKDIR)/%.class: %.java
	@echo $? >> .classes.list

$(CLASSPACKDIR)/%_Skel.class: %.java
	@echo $(JAVAPACKAGE).$(basename $?) >>.rmi.list

$(SERDIR)/%: %.sh
	@[ -d $(SERDIR) ] || mkdir -p $(SERDIR)
	cp $< $@
	chmod a+x $@

$(BIN_DIR)/%: %.sh
	@[ -d $(BIN_DIR) ] || mkdir -p $(BIN_DIR)
	cp $< $@
	chmod a+x $@

$(COPYSRCDIR)/%.java: %.java
	@[ -d $(COPYSRCDIR) ] || mkdir -p $(COPYSRCDIR)
	ln $< $@

%.java:	%.jpp
	@CLASSPATH="$(CLASSPATH)" ; PATH=$(PATH) ; export CLASSPATH PATH  ; \
	set -x ; \
	$(JPP) $(JPPFLAGS) $?

./.javacc_output/%.output: %.jj
	@CLASSPATH="$(CLASSPATH)" ; PATH=$(PATH) ; export CLASSPATH PATH  ; \
	set -x ; \
	$(JAVACC) -OUTPUT_DIRECTORY=./.javacc_output $(JCCFLAGS) $?
	@CLASSPATH="$(CLASSPATH)" ; PATH=$(PATH) ; export CLASSPATH PATH  ; \
	set -x ; \
	$(JAVAC) -d $(CLASS_DIR) $(JCFLAGS) `find .javacc_output -name '*.java' -print`
	>$@

$(CLASSPACKDIR)/%.genic_output:	%.txt
	$(GENDD) -d $(SERDIR) $<
	$(GENIC) -d $(CLASS_DIR) $(GENICFLAGS) $(SERDIR)/$(basename $<).ser
	>$@

all::
clean::
	rm -f $(CLASSPACKDIR)/core
check::
ejb-jar::


ifneq ($(FILES_CLASS), $(space))
all::	compil

compil:	classes

classes: delete_classlist $(FILES_CLASS) compile_classlist

delete_classlist:
	@rm -f .classes.list

compile_classlist:
	@[ -d $(CLASS_DIR) ] || mkdir -p $(CLASS_DIR)
	@CLASSPATH="$(CLASSPATH)" ; PATH=$(PATH) ; export CLASSPATH PATH  ; \
	if [ -s .classes.list ] ; \
	then	set -x ; \
		$(JAVAC) -d $(CLASS_DIR) $(JCFLAGS) $(shell if [ -s .classes.list ] ; then cat .classes.list; fi ); \
	fi

clean::
	rm -f $(CLASSPACKDIR)/*.class $(CLASSPACKDIR)/*.java
endif

ifneq ($(RMI_CLASSES),)
all::	rmi

rmi:	delete_rmilist $(FILES_RMI) compile_rmilist

delete_rmilist:
	@rm -f .rmi.list

compile_rmilist:
	@CLASSPATH="$(CLASSPATH)" ; PATH=$(PATH) ; export CLASSPATH PATH  ; \
	if [ -s .rmi.list ] ; \
	then	cd $(CLASS_DIR) ; set -x ; \
		$(RMIC) -d . $(RMICFLAGS) $(shell if [ -s .rmi.list ] ; then cat .rmi.list; fi ) ; \
	fi

ifneq ($(EXPLICIT_PROP),true)
all::	.recompile_stubs

.recompile_stubs:
	for i in $(FILES_STUB); \
		do (cp $$i $$i,; sed 's/java.rmi.server.RemoteStub/org.objectweb.jonas.rmifilters.RemoteStub/g' $$i, | sed 's/ref.invoke/this.invoke/g'  >$$i; rm $$i,); \
	done
	for i in $(FILES_SKEL); \
		do (cp $$i $$i,; sed 's/implements/extends org.objectweb.jonas.rmifilters.Skeleton implements/' $$i, | sed 's/call.releaseInputStream()/this.inRequest(call)/' | sed 's/call.getResultStream(true)/this.outReply(call)/' >$$i; rm $$i,); \
	done
	@CLASSPATH="$(CLASSPATH)" ; PATH=$(PATH) ; export CLASSPATH PATH  ; \
	set -x ; \
	$(JAVAC) -deprecation $(JCFLAGS) $(FILES_STUB) $(FILES_SKEL)
	>$@

clean::
	rm -f .recompile_stubs
endif
endif

ifneq ($(SCRIPTS),)
all::	$(FILES_SCRIPTS)

clean::
	rm -f $(FILES_SCRIPTS)

run:
	if [ -r *.properties ]; then cp *.properties $(CLASSPACKDIR); fi
	cd $(CLASSPACKDIR); run;
endif

ifneq ($(COMMANDS),)
all::	$(FILES_COMMAND)

clean::
	rm -f $(FILES_COMMAND)
endif

ifneq ($(JAVACCFILES),)
all::	$(FILES_PARSER)

clean::
	rm -rf ./.javacc_output
	rm -rf $(CLASSPACKDIR)/*.class
endif


ifneq ($(JARNAME),)
jar:
	[ -d $(LIB_DIR) ] || mkdir -p $(LIB_DIR)
	@(cd $(CLASS_DIR); \
	CLASSPATH="$(CLASSPATH)"; PATH=$(PATH) ; export CLASSPATH PATH ; \
	set -x ; \
	$(JAR) cv .) >$(LIB_DIR)/$(JARNAME).jar
endif

copysrc:: $(FILES_SRC)
ifneq ($(FILES_SRC), $(space))
	echo $(JAVAPACKAGE) >> $(JAVADOC_DIR)/package.list

tags::
	@etags -a -o $(PWD)/TAGS $(PWDSRC)/*.java $(PWDSRC)/*.jpp $(PWDSRC)/*.jj

endif

ifneq ($(BEANDD),)
all::	$(FILES_GENIC)

check::
	@for i in $(FILES_SER); \
	do \
		$(CHECKEJB) $(CHECKEJBFLAGS) $$i; \
	done

ejb-jar::
	@echo "Manifest File Creation: $(FILE_MANIFEST)"
	@>$(FILE_MANIFEST)
	@for i in $(FILES_SER_MF); \
	do \
		echo "Name: $$i" >>$(FILE_MANIFEST); \
		echo "Enterprise-Bean: True" >>$(FILE_MANIFEST); \
		echo "" >>$(FILE_MANIFEST); \
	done
	@echo "ejb-jar File Creation: $(FILE_EJBJAR)"
	@cd $(LIB_DIR); \
	CLASSPATH="$(CLASSPATH)"; PATH=$(PATH) ; export CLASSPATH PATH ; \
	set -x ; \
	jar cvmf $(FILE_MANIFEST) $(FILE_EJBJAR) `find $(PACKDIR) -name '*.class' -print |grep -v '\/JOnAS'` $(FILES_SER_MF)

clean::
	rm -f $(FILES_SER)
	rm -f $(CLASSPACKDIR)/*.genic_output
	rm -f $(CLASSPACKDIR)/*.class $(CLASSPACKDIR)/*.java
	rm -f $(LIB_DIR)/$(FILE_EJBJAR)
endif

ifneq ($(SUBDIRS),)
tags::
	@rm -f TAGS

all clean run check ejb-jar tags copysrc::
	@for p in $(SUBDIRS); do (cd ./$$p; $(MAKE) $@); done
endif

javadoc: jdinit copysrc
	@CLASSPATH="$(CLASSPATH)"; export CLASSPATH; set -x ; \
	$(JAVADOC) -d $(JAVADOC_DIR) -sourcepath $(SRCTMP_DIR) `cat $(JAVADOC_DIR)/package.list`

jdinit:
	@[ -d $(JAVADOC_DIR) ] || mkdir -p $(JAVADOC_DIR)
	rm -f $(JAVADOC_DIR)/package.list

clean::
	rm -rf $(JAVADOC_DIR) $(SRCTMP_DIR)

ifneq ($(LOCALFILES),)
all::
	[ -d $(OUTPUT_DIR) ] || mkdir -p $(OUTPUT_DIR)
	cp -Rf $(LOCALFILES) $(OUTPUT_DIR)
endif

clean_world: clean
	-rm -rf $(OUTPUT_DIR) $(CLASS_DIR)

env:
	@echo CLASSPATH=$(CLASSPATH)
	@echo PATH=$(PATH)
	@echo JAVAPACKAGE=$(JAVAPACKAGE)
	@echo FILES_SRC=$(FILES_SRC)
	@echo JDKVERSION=$(JDKVERSION)
	@echo JDKDIR=$(JDKDIR)
	@echo JDKBIN=$(JDKBIN)
	@echo OSTYPE=$(OSTYPE)
	@echo JTACLASSES=$(JTA_CLASSES)
