/*
 * The contents of this file are subject to the JOnAS Public License Version 
 * 1.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License on the JOnAS web site.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.
 * See the License for the specific terms governing rights and limitations under 
 * the License.
 *
 * The Original Code is JOnAS application server code released July 1999.
 *
 * The Initial Developer of the Original Code is Bull S.A.
 * The Original Code and portions created by Bull S.A. are
 *    Copyright (C) 1999 Bull S.A. All Rights Reserved.
 *
 * Contributor(s): ______________________________________.
 *
 * --------------------------------------------------------------------------
 * $Id$
 * --------------------------------------------------------------------------
 */


package org.objectweb.jonas.common;

/**
 * This class implements useful methods not already implemented
 * in the java.lang.String class.
 */

public class JString {

    private java.lang.String value;

    public JString(java.lang.String s) {
	value = new String(s);
    }

    /**
     * Returns a new string resulting from replacing the first occurence, or all occurrences,
     * of sOld string in this string with sNew string. 
     * If the string sOld does not occur in the character sequence represented by this object,
     * then this string is returned. 
     * @param  sOld      the old string
     * @param  sNew      the new string
     * @param  all=true  all occurrences of the sOld string are replaced
     * @param  all=false only the first occurrence of the sOld string is replaced
     * @return a string derived from this string by replacing the first ocurrence,
     *         or every occurrence of sOld with sNew.
     */
    public java.lang.String replace(java.lang.String sOld, java.lang.String sNew, boolean all) {
	String valReturn = new String("");
	int l  = value.length();
	int lo = sOld.length();
	int ln = sNew.length();
	int i = 0; int j;
	while (i <= l) {
	    j = value.indexOf(sOld, i);
	    if (j == -1) {
		valReturn = valReturn.concat(value.substring(i, l));
		i = l + 1;  // Stop, no more occurrence.
	    } else {
		valReturn = valReturn.concat(value.substring(i, j));
		valReturn = valReturn.concat(sNew);
		i = j + lo;
		if (!all) { // Stop, replace the first occurrence only.
		    valReturn = valReturn.concat(value.substring(i, l));
		    i = l + 1; // Stop, replace the first occurrence only.
		}
	    }
	}
	return(valReturn);
    }

    /**
     * Returns a new string resulting from replacing all occurrences,
     * of sOld string in this string with sNew string. 
     * If the string sOld does not occur in the character sequence represented by this object,
     * then this string is returned. 
     * @param  sOld      the old string
     * @param  sNew      the new string
     * @return a string derived from this string by replacing every occurrence of sOld with sNew.
     */
    public java.lang.String replace(java.lang.String sOld, java.lang.String sNew) {
	return(replace(sOld, sNew, true));
    }

    /**
     * Returns a String object representing this JString's value
     */
    public java.lang.String toString() {
	if (value == null) {
	    return(new String("null"));
	} else {
	    return(value);
	}
    }
}
